/***************************************************************************************
* File name    :	AES.h
* Function     :	The header of AES.c
* Author       : 	Hongjz
* Date         :	2015/09/15
* Version      :    v1.0
* Description  :    
* ModifyRecord :
*****************************************************************************************/
#ifndef AES_H_
#define AES_H_

/***************************************************************************
* Include Header Files
***************************************************************************/


/**************************************************************************
* Global Macro Definition
***************************************************************************/

#define AES_ENCRYPT 1
#define AES_DECRYPT 2 

#define AES128_CBC 1
#define AES128_ECB 2 
#define AES192_CBC 3
#define AES192_ECB 4
#define AES256_CBC 5
#define AES256_ECB 6

/**************************************************************************
* Global Type Definition
***************************************************************************/
typedef enum 
{
	AES_Success = 0, 
	AES_TYPE_Err,		//ʹ
	AES_MODE_Err,		//ģʽ
	AES_KEY_LEN_Err,	//Կȴ
	AES_Len_Err,		//볤ȴ16ֽڵΪ0ȴ1024
	AES_OVERTIME_Err,	//Ӳʱ
}AES_RT;
/**************************************************************************
* Global Variable Declaration
***************************************************************************/

/**************************************************************************
* Global Functon Declaration
***************************************************************************/

/***************************************************************************************
ԭͣ	UINT8 AES_Init(UINT8* pKey, UINT32 nKeyLen)
˵	ʼAESԿ
˵	pKey [I] --- Կ
						KeyLen [I] --- ԿȣΪ16ֽڣΪ128bitʱ24ֽڣΪ192bitʱ32ֽڣΪ256bitʱ
ֵ	0ɹֵʧ
ע	
*****************************************************************************************/
extern	UINT8 AES_Init(UINT8* pKey,UINT32 nKeyLen);

/*********************************************************************************************************
ԭͣ	UINT8 _Aes_Run(UINT8 nType,UINT8 nMode,UINT32 nAddr,UINT16 nDataLen)
˵	AESӲ
˵	UINT8  nType [I] -- AES_ENCRYPT/AES_DECRYPT
			UINT8  nMode [I] -- ES128_ECB/AES192_ECB/AES256_ECB
			UINT32 nAddr [I] -- ׵ַҲ׵ַÿռΪ0x20020000~0x20020800
			UINT16 nDataLen [I] -- ݳȣΪ16ıPadding
ֵ	0ɹֵʧ
ע	úֱӵ㷨ҪûݷŵnAddrַnAddrַȡ
********************************************************************************************************/	 
extern	UINT8 _Aes_Run(UINT8 nType,UINT8 nMode,UINT32 nAddr,UINT16 nDataLen);

/***************************************************************************************
ԭͣ	UINT8 AES_Run(UINT8 nType, UINT8 nMode, UINT8* pIn, UINT8* pOut, UINT16 nDataLen, UINT8* pIV)
˵	AESܻܡ
˵	nType [I] --- ܻܣ£
						#define 	AES_ENCRYPT 		1
						#define 	AES_DECRYPT 		2
						nMode [I] --- ECBCBC£
						#define	AES128_CBC 		1
						#define	AES128_ECB 		2 
						#define	AES192_CBC 		3
						#define	AES192_ECB 		4
						#define	AES256_CBC 		5
						#define	AES256_ECB 		6 
						pIN [I] --- Ҫܻܵݡ
						pOut [O] --- 
						nDataLen [I] --- ݳȣΪ16ıPadding
						PIV[IO] --- IVصIVֵCBCģʽ´㣬Ϊ16ֽڡ
ֵ	0ɹֵʧ
ע	ΪIVͬʱҪշصIVҪԭʼIVֵС
*****************************************************************************************/
extern	UINT8 AES_Run(UINT8 nType,UINT8 nMode,UINT8* pIn,UINT8* pOut,UINT16 nDataLen,UINT8* pIV);
/*********************************************************************************************************
ԭͣ	void AesVersion(INT8 data[12])
˵	AES㷨汾Żȡ
˵	INT8 data [O] -- 㷨汾			
ֵ	
ע	
********************************************************************************************************/ 
extern	void AesVersion(INT8 data[12]);
#endif /*AES_H_*/
